%bcond_with libipa

%define debug_package %{nil}

%define __USE_SCL	0
%if %{with libipa}
%if  0%{?centos} == 6
%ifarch x86_64
%define __USE_SCL	1
%endif
%endif
%endif

%if %{__USE_SCL} > 0
	%define POSTGRESQL postgresql92
	%define PYTHON     python27
	%define _scl_prefix /opt/rh
	%define python_sitelib_old_1 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=False)")
	%define python_sitelib_old_2 %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
	%define python_sitelib	     %(echo python -c '"from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)"' | scl enable %{PYTHON} -)
%else
	%define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(plat_specific=True)")
%endif

%define name    silk
%define version 3.10.2
%if %{with libipa}
	%define release 4
%else
	%define release 3
%endif

Name:			%{name}
Version:		%{version}
Release:		%{release}%{?dist}
Summary:		SiLK: A network flow collection and analysis package
License:		GPLv2
Vendor:			CERT Network Situational Awareness <netsa-help@cert.org>
URL:			http://tools.netsa.cert.org/silk/
Source:			%{name}-%{version}.tar.gz
%if 0%{?centos} == 5
Patch1: %{name}-%{version}-patch-001
%endif
Group:			Applications/System
Prefix:			/usr
Requires:		adns, libfixbuf >= 1.0.0, gnutls >= 1.4.1, lzo, libpcap, zlib
Requires(post):		/sbin/ldconfig, /sbin/chkconfig
Requires(preun):	/sbin/chkconfig
Requires(postun):	/sbin/ldconfig
Requires:		filesystem
BuildRequires:		adns-devel, libfixbuf-devel >= 1.0.0, gnutls-devel >= 1.4.1, lzo-devel, libpcap-devel, zlib-devel
BuildRequires:		libselinux
BuildRoot:		%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
%if 0%{?fedora} >= 19
BuildRequires:		perl-podlators
%endif
%if 0%{?fedora} >= 18
BuildRequires:		perl-Pod-Parser
%endif
%if %{with libipa}
%if 0%{?fedora} >= 17
%define PGSQL_BASE		%{prefix}
%define PGSQL_PKG_CONFIG        %{PGSQL_BASE}/bin/pkg-config
%define PGSQL_PKG_CONFIG_FILE   %{_libdir}/pkgconfig/libpq.pc
%define IPA_PKG_CONFIG_FILE     %{_libdir}/pkgconfig/libipa.pc
BuildRequires:			postgresql-devel ipa-devel
Requires:       		postgresql-libs  ipa
BuildRequires:			python-devel >= 2.4
Requires:			python >= 2.4
%endif
%if %{__USE_SCL}
%define PGSQL_BASE		%{prefix}
%define PGSQL_PKG_CONFIG        %{PGSQL_BASE}/bin/pkg-config
%define PGSQL_PKG_CONFIG_FILE    %{_libdir}/pkgconfig/libpq.pc
%define IPA_PKG_CONFIG_FILE      %{_libdir}/pkgconfig/libipa.pc
BuildRequires:			%{POSTGRESQL}-postgresql-devel ipa-devel
Requires:       		%{POSTGRESQL}-postgresql-libs  ipa
BuildRequires:			%{PYTHON}-python-setuptools %{PYTHON}-python-devel
Requires:       		%{PYTHON}-python-setuptools
%endif
%endif
%if 0%{?centos} == 5
BuildRequires:			 %(basename %{__python})-devel
%else
BuildRequires:			 %(basename %{__python})-devel
%endif

# To apply a patch to the SiLK sources: (1)put the patch file into the
# SOURCES directory, (2)uncomment the 'Patch0:' line below, (3)add the
# name of the patch file after the 'Patch0:', (4)uncomment the
# '%patch0' line in the 'prep' section below.
#
# To apply a second patch, repeat the process using 'Patch1:' and
# '%patch1' in place of 'Patch0:' and '%patch0'.
#
#Patch0:
#Patch1:
#Patch2:
#Patch3:
#Patch4:

%define data_rootdir    /data
%define with_PYTHON     1
%ifarch x86_64
%define py_sitepkg      %{nil}%{python_sitelib}
%define py_sitepkg_silk %{nil}%{python_sitelib}/silk
%else
%define py_sitepkg      %{nil}%{python_sitelib}
%define py_sitepkg_silk %{nil}%{python_sitelib}/silk
%endif

# This file contains the list of files that comprise the silk-analysis
# RPM.  It is created during the 'install' phase.
%define sk_analysis_file   analysis-list.txt
%define sk_analysis_path   $RPM_BUILD_DIR/%{name}-%{version}/%{sk_analysis_file}

# This file is empty or contains the list of packing-logic plug-ins
# for the silk-rwflopack RPM.  It is created during 'install'.
%define sk_rwflowpack_file rwflowpack-list.txt
%define sk_rwflowpack_path $RPM_BUILD_DIR/%{name}-%{version}/%{sk_rwflowpack_file}

#######################################################################
# RCSIDENT("$SiLK: silk.spec.in d298f6bb5a90 2013-05-31 21:16:48Z mthomas $")
#######################################################################

%description
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

SiLK consists of two sets of tools: a packing system and analysis
suite. The packing system receives network flow information from
Netflow v5 or any IPFIX-based flowmeter and converts them into a more
space efficient format, recording the packed records into
service-specific, binary flat files. The analysis suite consists of
tools which can read these flat files and then perform various query
operations, ranging from per-record filtering to statistical analysis
of groups of records. The analysis tools interoperate using pipes,
allowing a user to develop a relatively sophisticated query from a
simple beginning.

%prep
echo Building %{name}-%{version}-%{release}
%setup -q
#
# To apply patches, see description near 'Patch0:' above.
#
#%patch0 -p1
#%patch1 -p1
#%patch2 -p1
#%patch3 -p1
#%patch4 -p1
%if 0%{?centos} == 5
%patch1 -p1
%endif
########################################################################
# The system script that computes dependencies misidentifies the 
# python 2.7 dependency, so it is necessary to remove it from the
# dependency determination. 
########################################################################
%if %{__USE_SCL}
mkdir -p %{_builddir}/%{name}-%{version}
cat > %{_builddir}/%{name}-%{version}/pythondeps.sh << \EOF
#!/bin/sh
%{__python_requires} $* | sed -e 's/python(abi) = 2.7/python27-python(abi) = 2.7/'
EOF
chmod +x %{_builddir}/%{name}-%{version}/pythondeps.sh
%define __python_requires %{_builddir}/%{name}-%{version}/pythondeps.sh
%endif

%build
%if 0%{?rhel} == 5
PYTHON=%{__python}
export PYTHON
%endif
%if %{with libipa}
%if 0%{?__USE_SCL} > 0
export PYTHONPATH=%{python_sitelib}:%{python_sitelib_old_1}:%{python_sitelib_old_2}
source %_scl_prefix/%{POSTGRESQL}/enable
source %_scl_prefix/%{PYTHON}/enable
%else
export LIBIPA_CFLAGS="%(echo `if [ -e %{PGSQL_PKG_CONFIG_FILE} ]; then %{PGSQL_PKG_CONFIG} --cflags libpq; fi; if [ -e %{IPA_PKG_CONFIG_FILE} ]; then pkg-config --cflags libipa; fi`)"
export LIBIPA_LIBS="%(  echo `if [ -e %{PGSQL_PKG_CONFIG_FILE} ]; then %{PGSQL_PKG_CONFIG} --libs   libpq; fi; if [ -e %{IPA_PKG_CONFIG_FILE} ]; then pkg-config --libs   libipa; fi`)"
echo LIBIPA_CFLAGS=$LIBIPA_CFLAGS LIBIPA_LIBS==$LIBIPA_LIBS=
%endif
%endif
%configure --enable-data-rootdir=%{data_rootdir}  --disable-assert --enable-asa-zero-packet-hack --enable-ipv6 --enable-localtime --enable-output-compression=lzo1x --without-c-ares \
	%{?_with_libipa} --with-python --disable-static
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool
make %{?_smp_mflags}

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
%if %{__USE_SCL}
        export PYTHONPATH=%{python_sitelib}:%{python_sitelib_old_1}:%{python_sitelib_old_2}
        mkdir -p %{buildroot}%{_sysconfdir}/ld.so.conf.d
        echo printenv | scl enable %{POSTGRESQL} %{PYTHON} -| sed -n 's/LD_LIBRARY_PATH=//p' > %{buildroot}%{_sysconfdir}/ld.so.conf.d/%{name}-%{_arch}.conf
	echo make DESTDIR=$RPM_BUILD_ROOT install | scl enable %{POSTGRESQL} %{PYTHON} -
%else
	make DESTDIR=$RPM_BUILD_ROOT install
%endif
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig
mv $RPM_BUILD_ROOT/%{_datadir}/silk/etc/*.conf $RPM_BUILD_ROOT/%{_sysconfdir}/sysconfig
mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/init.d
for sk_initd in $RPM_BUILD_ROOT/%{_datadir}/silk/etc/init.d/* ; do \
    sed 's,^\(DEFAULT_SCRIPT_CONFIG_LOCATION=\),\1%{_sysconfdir}/sysconfig,' $sk_initd > /$RPM_BUILD_ROOT/%{_sysconfdir}/init.d/`basename $sk_initd` ; \
    rm -f $sk_initd ; \
done
rmdir $RPM_BUILD_ROOT/%{_datadir}/silk/etc/init.d
rmdir $RPM_BUILD_ROOT/%{_datadir}/silk/etc
rm -f $RPM_BUILD_ROOT/%{_libdir}/silk/*.la
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/silk

# build the file list to use for the silk-analysis RPM
rm -f %{sk_analysis_path}
touch %{sk_analysis_path}
echo '%defattr(-,root,root)' >> %{sk_analysis_path}
echo '%{_datadir}/silk/addrtype-templ.txt' >> %{sk_analysis_path}

find $RPM_BUILD_ROOT/%{_bindir} -type f -print | \
    grep -v rwfileinfo | \
    grep -v rwsiteinfo | \
    grep -v silk_config | \
    sed "s!$RPM_BUILD_ROOT/*!/!" >> %{sk_analysis_path}
find $RPM_BUILD_ROOT/%{_mandir}/man1 -type f -print | \
    grep -v rwfileinfo | \
    grep -v rwsiteinfo | \
    grep -v silk_config | \
    sed "s!$RPM_BUILD_ROOT/*!/!" | \
    sed 's/$/*/' >> %{sk_analysis_path}
find $RPM_BUILD_ROOT/%{_mandir}/man3 -type f -print | \
    grep -v silk-plugin | \
    sed "s!$RPM_BUILD_ROOT/*!/!" | \
    sed 's/$/*/' >> %{sk_analysis_path}
find $RPM_BUILD_ROOT/%{_libdir}/silk -name '*.so' -type f -print | \
    grep -v packlogic | \
    sed "s!$RPM_BUILD_ROOT/*!/!" >> %{sk_analysis_path}

%if %{with_PYTHON}
rm -f $RPM_BUILD_ROOT/%{py_sitepkg_silk}/*.a
rm -f $RPM_BUILD_ROOT/%{py_sitepkg_silk}/*.la
# netsa_silk is packaged by netsa python
rm -f $RPM_BUILD_ROOT/%{py_sitepkg}/*.py* 
echo '%dir '%{py_sitepkg_silk} >> %{sk_analysis_path}
echo %{py_sitepkg_silk}'/*' >> %{sk_analysis_path}
%endif


# build the list of plug-ins to use as part of the silk-rwflowpack
# RPM.  This is empty if static packing logic is used.
rm -f %{sk_rwflowpack_path}
touch %{sk_rwflowpack_path}
find $RPM_BUILD_ROOT/%{_libdir}/silk -name 'packlogic*.so' -type f -print | \
    sed "s!$RPM_BUILD_ROOT/*!/!" >> %{sk_rwflowpack_path}

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


#  ###################################################################
#  silk-common

%package common
Group: Applications/System
Summary: SiLK Toolset: Common Libraries and Configuration Files
%if %{with_PYTHON}
Provides: netsa_silk_impl
%endif

%description common
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-common package contains the libraries and configuration files
required by the other parts of SiLK Toolset, as well as generally
useful utilities.

%files common
%defattr(-,root,root)
%{_bindir}/rwfileinfo
%{_mandir}/man1/rwfileinfo.1*
%{_bindir}/rwsiteinfo
%{_mandir}/man1/rwsiteinfo.1*
%{_libdir}/*.so.*
%dir %{_libdir}/silk
%{_mandir}/man5/*
%{_mandir}/man7/*
%dir %{_datadir}/silk
%{_datadir}/silk/*-silk.conf
%{_datadir}/silk/silk.magic
%if %{__USE_SCL}
%{_sysconfdir}/ld.so.conf.d/%{name}-%{_arch}.conf
%endif

%post common
/sbin/ldconfig

%postun common
/sbin/ldconfig


#  ###################################################################
#  silk-analysis

%package analysis
Group: Applications/System
Summary: SiLK Toolset: The Analysis Suite
Requires: silk-common

%description analysis
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-analysis package contains the analysis tools that query the
SiLK Flow data collected by rwflowpack (contained in the
silk-rwflowpack package) and summarize that data in various ways.

# The file list gets generated at install time.  This list contains
# almost everything except:
# -- packlogic-*.so files used by rwflowpack (silk-rwflowpack RPM)
# -- rwfileinfo (silk-common RPM)
# -- rwsiteinfo (silk-common RPM)
# -- silk_config (silk-devel RPM)
%files analysis -f %{sk_analysis_file}


#  ###################################################################
#  silk-rwflowpack

%package rwflowpack
Group: Applications/System
Summary: SiLK Toolset: The Packer
Requires: silk-common

%description rwflowpack
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-rwflowpack package converts NetFlow v5 or IPFIX (Internet
Protocol Flow Information eXport) data to the SiLK Flow record format,
categorizes each flow (e.g., as incoming or outgoing), and stores the
data in binary flat files within a directory tree, with one file per
hour-category-sensor tuple.  Use the tools from the silk-analysis
package to query this data.  rwflowpack may capture the data itself,
or it may process files that have been created by flowcap (see the
silk-flowcap package).

%files rwflowpack -f %{sk_rwflowpack_file}
%defattr(-,root,root)
%{_sbindir}/rwflowpack
%{_sbindir}/rwguess
%{_sbindir}/rwpackchecker
%dir %{_mandir}/man8
%{_mandir}/man8/rwflowpack.8*
%{_mandir}/man8/rwguess.8*
%{_mandir}/man8/rwpackchecker.8*
%config(noreplace) %{_sysconfdir}/sysconfig/rwflowpack.conf
%attr(755,root,root) %{_sysconfdir}/init.d/rwflowpack
%attr(750,root,root) %dir %{_localstatedir}/silk

%post rwflowpack
function runlvl(){
    ( /sbin/chkconfig --del $1 || true )
    /sbin/chkconfig --add $1
    /sbin/chkconfig --levels 345 $1 on
    /sbin/chkconfig --levels 016 $1 off
}

runlvl rwflowpack

%preun rwflowpack
if [ "$1" = 0 ]; then
    /sbin/chkconfig --del rwflowpack
fi


#  ###################################################################
#  silk-flowcap

%package flowcap
Group: Applications/System
Summary: SiLK Toolset: Remote Flow Collection
Requires: silk-common

%description flowcap
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-flowcap package contains flowcap, a daemon to capture NetFlow
v5 or IPFIX flows (Internet Protocol Flow Information eXport), to
store the data temporarily in files on its local disk, and to forward
these files over the network to a machine where rwflowpack processes
the data.  flowcap is typically used with an rwsender-rwreceiver pair
to move the files across the network.

%files flowcap
%defattr(-,root,root)
%{_sbindir}/flowcap
%dir %{_mandir}/man8
%{_mandir}/man8/flowcap.8*
%config(noreplace) %{_sysconfdir}/sysconfig/flowcap.conf
%attr(755,root,root) %{_sysconfdir}/init.d/flowcap
%attr(750,root,root) %dir %{_localstatedir}/silk

%post flowcap
function runlvl(){
    ( /sbin/chkconfig --del $1 || true )
    /sbin/chkconfig --add $1
    /sbin/chkconfig --levels 345 $1 on
    /sbin/chkconfig --levels 016 $1 off
}

runlvl flowcap

%preun flowcap
if [ "$1" = 0 ]; then
    /sbin/chkconfig --del flowcap
fi


#  ###################################################################
#  silk-rwflowappend

%package rwflowappend
Group: Applications/System
Summary: SiLK Toolset: Remote Data Storage Appending Daemon
Requires: silk-common

%description rwflowappend
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-rwflowappend package is used when the final storage location
of SiLK data files is on a different machine than that where the files
are created by the rwflowpack daemon (see the silk-rwflowpack
package).  rwflowappend watches a directory for SiLK data files and
appends those files to the final storage location where the SiLK
analysis tools (from the silk-analysis package) can process them.  To
move the files from rwflowpack to rwflowappend, an rwsender-rwreceiver
pair is typically used.

%files rwflowappend
%defattr(-,root,root)
%{_sbindir}/rwflowappend
%dir %{_mandir}/man8
%{_mandir}/man8/rwflowappend.8*
%config(noreplace) %{_sysconfdir}/sysconfig/rwflowappend.conf
%attr(755,root,root) %{_sysconfdir}/init.d/rwflowappend
%attr(750,root,root) %dir %{_localstatedir}/silk

%post rwflowappend
function runlvl(){
    ( /sbin/chkconfig --del $1 || true )
    /sbin/chkconfig --add $1
    /sbin/chkconfig --levels 345 $1 on
    /sbin/chkconfig --levels 016 $1 off
}

runlvl rwflowappend

%preun rwflowappend
if [ "$1" = 0 ]; then
    /sbin/chkconfig --del rwflowappend
fi


#  ###################################################################
#  silk-rwreceiver

%package rwreceiver
Group: Applications/System
Summary: SiLK Toolset: File Transfer Receiver
Requires: silk-common

%description rwreceiver
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-rwreceiver package contains a program (rwreceiver) which
receives files over the network from one or more rwsender programs.
rwsender-rwreceiver pairs are used to move files from a machine
running flowcap and one running rwflowpack, or from the rwflowpack
machine to machine(s) running rwflowappend.

%files rwreceiver
%defattr(-,root,root)
%{_sbindir}/rwreceiver
%dir %{_mandir}/man8
%{_mandir}/man8/rwreceiver.8*
%config(noreplace) %{_sysconfdir}/sysconfig/rwreceiver.conf
%attr(755,root,root) %{_sysconfdir}/init.d/rwreceiver
%attr(750,root,root) %dir %{_localstatedir}/silk

%post rwreceiver
function runlvl(){
    ( /sbin/chkconfig --del $1 || true )
    /sbin/chkconfig --add $1
    /sbin/chkconfig --levels 345 $1 on
    /sbin/chkconfig --levels 016 $1 off
}

runlvl rwreceiver

%preun rwreceiver
if [ "$1" = 0 ]; then
    /sbin/chkconfig --del rwreceiver
fi


#  ###################################################################
#  silk-rwsender

%package rwsender
Group: Applications/System
Summary: SiLK Toolset: File Transfer Sender
Requires: silk-common

%description rwsender
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-rwsender package contains a program (rwsender) which
transmits files over the network to one or more rwreceiver programs.
rwsender-rwreceiver pairs are used to move files from a machine
running flowcap and one running rwflowpack, or from the rwflowpack
machine to machine(s) running rwflowappend.

%files rwsender
%defattr(-,root,root)
%{_sbindir}/rwsender
%dir %{_mandir}/man8
%{_mandir}/man8/rwsender.8*
%config(noreplace) %{_sysconfdir}/sysconfig/rwsender.conf
%attr(755,root,root) %{_sysconfdir}/init.d/rwsender
%attr(750,root,root) %dir %{_localstatedir}/silk

%post rwsender
function runlvl(){
    ( /sbin/chkconfig --del $1 || true )
    /sbin/chkconfig --add $1
    /sbin/chkconfig --levels 345 $1 on
    /sbin/chkconfig --levels 016 $1 off
}

runlvl rwsender

%preun rwsender
if [ "$1" = 0 ]; then
    /sbin/chkconfig --del rwsender
fi


#  ###################################################################
#  silk-rwpollexec

%package rwpollexec
Group: Applications/System
Summary: SiLK Toolset: Batch Command Executor
Requires: silk-common

%description rwpollexec
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-rwpollexec package contains a program (rwpollexec) which
monitors a directory for incoming files.  For each file, rwpollexec
executes a user-specified command.  If the command completes
successfully, the file is either moved to an archive directory or
deleted.

%files rwpollexec
%defattr(-,root,root)
%{_sbindir}/rwpollexec
%dir %{_mandir}/man8
%{_mandir}/man8/rwpollexec.8*
%config(noreplace) %{_sysconfdir}/sysconfig/rwpollexec.conf
%attr(755,root,root) %{_sysconfdir}/init.d/rwpollexec
%attr(750,root,root) %dir %{_localstatedir}/silk

%post rwpollexec
function runlvl(){
    ( /sbin/chkconfig --del $1 || true )
    /sbin/chkconfig --add $1
    /sbin/chkconfig --levels 345 $1 on
    /sbin/chkconfig --levels 016 $1 off
}

runlvl rwpollexec

%preun rwpollexec
if [ "$1" = 0 ]; then
    /sbin/chkconfig --del rwpollexec
fi


#  ###################################################################
#  silk-devel

%package devel
Group: Development/Libraries
Summary: The SiLK Toolset development files

%description devel
SiLK, the System for Internet-Level Knowledge, is a collection of
traffic analysis tools developed by the CERT Network Situational
Awareness Team (CERT NetSA) to facilitate security analysis of large
networks. The SiLK tool suite supports the efficient collection,
storage and analysis of network flow data, enabling network security
analysts to rapidly query large historical traffic data sets. SiLK is
ideally suited for analyzing traffic on the backbone or border of a
large, distributed enterprise or mid-sized ISP.

The silk-devel package contains the development libraries and headers
for SiLK.  This package is required to build additional applications
or to build shared libraries for use as plug-ins to the SiLK analysis
tools.

%files devel
%defattr(-,root,root)
%{_includedir}
%{_libdir}/*.so
%{_libdir}/*.la
%{_bindir}/silk_config
%{_mandir}/man1/silk_config.1*
%{_mandir}/man3/silk-plugin.3*


%changelog
* Mon Jul  6 2015 Lawrence Rogers <lrr@cert.org> 3.10.2-3/4
* Release 3.10.2-3/4
	Rebuild for libfixbuf-1.7.0.

* Thu May 21 2015 Lawrence Rogers <lrr@cert.org> 3.10.2-1/2
* Release 3.10.2-1/2
	Remove support for fixbuf releases prior to libfixbuf-1.4.0.
	Fix several bugs related to IPv6 addresses.

* Thu Feb 26 2015 Lawrence Rogers <lrr@cert.org> 3.10.1-1/2
* Release 3.10.1-1/2
	rwstats and rwuniq
		Change how rwstats and rwuniq use temporary files when distinct counts are being computed to fix the issue where the tool
		  would sometimes exit with "Error merging values from temporary file".
		Use compression when writing to temporary files.
	rwsort, rwcombine, and rwdedupe
		Use compression when writing to temporary files.
	rwappend
		Fix a bug that could cause rwappend to remove /dev/null when run as root.
	flowcap
		Allow accept-from-host in sensor.conf to take multiple arguments.
	rwflowpack
		Allow accept-from-host in sensor.conf to take multiple arguments.
		Fix a potential crash when using --input-mode=respool and rwflowpack runs out of file descriptors.
	Building
		Fix a bug in the "Requires:" line of the generated silk.spec file when multiple optional dependencies are not available.
		Do not install rwscanquery when configure fails to find Perl's DBI module.

* Thu Dec 18 2014 Lawrence Rogers <lrr@cert.org> 3.10.0-1/2
* Release 3.10.0-1/2
	Important bug fixes in rwfilter and rwsetmember.
	rwflowpack can categorize flow records using an IPset.
	Several changes to logging in rwflowpack and flowcap, including a new default value.
	Additional changes and bug fixes.

* Wed Dec 10 2014 Lawrence Rogers <lrr@cert.org> 3.9.0-9/10
* Release 3.9.0-9/10
	Rebuild for libfixbuf-1.6.2.

* Wed Oct 15 2014 Lawrence Rogers <lrr@cert.org> 3.9.0-7/8
* Release 3.9.0-7/8
	Rebuild for libfixbuf-1.6.1.

* Wed Oct 8 2014 Lawrence Rogers <lrr@cert.org> 3.9.0-5/6
* Release 3.9.0-5/6
	Removed Obsoletes clause.

* Mon Sep 29 2014 Lawrence Rogers <lrr@cert.org> 3.9.0-3/4
* Release 3.9.0-3/4
	Rebuild for libfixbuf-1.6.0.

* Thu Sep 25 2014 Lawrence Rogers <lrr@cert.org> 3.9.0-1
* Release 3.9.0-1
	New tool rwcombine creates a single flow record from multiple records that represent a single, long-lived session.
	Several enhancements to rwmatch.
	Support for collecting sFlow v5 records (uses libfixbuf-1.6.0).
	Additional enhancements and bug fixes.

* Thu Jul 31 2014 Lawrence Rogers <lrr@cert.org> 3.8.3-1
* Release 3.8.3-1
	rwstats and rwuniq
		Fix a bug when --fields contained "dPort" followed by "icmpTypeCode" that caused the "dPort" field to display as 0.
	Additional changes and bug fixes

* Thu Apr 24 2014 Lawrence Rogers <lrr@cert.org> 3.8.2-1
* Release 3.8.2-1
	Add multiple thread support to rwflowappend.
	Support logging of IPFIX and NetFlow v9 templates received by rwflowpack and flowcap.
	Revision 1 - without IPA
	Revision 2 - with IPA

* Mon Mar 17 2014 Lawrence Rogers <lrr@cert.org> 3.8.1-2
* Release 3.8.1-2
	Took the time to make the build process cleaner so that it does not try to use programs that aren't installed.

* Thu Jan 30 2014 Lawrence Rogers <lrr@cert.org> 3.8.1-1
* Release 3.8.1-1
	See http://tools.netsa.cert.org/silk/releasenotes.html#release-3.8.1 for the changes in this release.

* Thu Nov 21 2013 Lawrence Rogers <lrr@cert.org> 3.8.0-1
* Release 3.8.0-1
	Allow rwpmaplookup to print the range that contains the key
	Improve handling of records from some devices that export NetFlow v9
	Add support for libfixbuf-1.4.0 and remove support for releases prior to libfixbuf-1.2.0

* Sun Aug 18 2013 Lawrence Rogers <lrr@cert.org> 3.7.2-1
* Release 3.7.2-1
	PySiLK changes
		Add IPSet.is_ipv6() and IPSet.convert() methods.
		Fix a bug when saving an IPv6-IPset that contains only IPv4 addresses.
	IPset bug fixes
		Fix bugs when computing the union or intersection of an IPv4-IPset and an IPv6-IPset that contains only IPv4 addresses.
	rwfilter bug fixes
		Fix a spurious warning when loading an IPset.
		Fix a memory issue during shutdown when an argument to one of the --*cidr switches (--scidr, --dcidr, etc) is mistyped.
	rwflowpack, flowcap bug fixes
		Fix a bug where the daemon failed to read TCP flags contained in a SubTemplateMultiList when reading IPFIX data over the network.
		Fix a memory leak when receiving IPFIX data containing a SubTemplateList or a SubTemplateMultiList.
* Thu May 30 2013 Lawrence Rogers <lrr@cert.org> 3.7.1-1
* Release 3.7.1-1
	rwpmaplookup enhancement
		Add --ipset-files switch that supports using IPsets to query prefix maps.
	rwdedupe bug fix
		Fix a crash that would occur when using --xargs with an empty list of files.
	rwsort bug fix
		Create a valid SiLK Flow file when using --xargs with an empty list of files.
	rwcut bug fix
		Print the title line when using --xargs with an empty list of files.
	rwrecgenerator bug fix
		Fix a bug when using --sensor-prefix-map that would set either the source or destination address to a random value.
	Building
		Fix a small issue in the silk.spec file when the dist RPM macro was not defined.

* Thu May 30 2013 Lawrence Rogers <lrr@cert.org> 3.7.0-1
* Release 3.7.0-1
	Add a new IPset file format which requires less disk space.
	Add new --ip-format switch to control how IPs are displayed.
	Add new --any-index and --any-cc switches to rwfilter.
	Add manual pages for rwflowpack's packing-logic plug-ins.
	Change how rwflowpack and flowcap report out-of-sequence NetFlow V5 packets.

* Tue Apr 23 2013 Lawrence Rogers <lrr@cert.org> 3.6.1-1
* Release 3.6.1-1
	Fix a bug in rwflowpack that caused the --pack-interfaces switch to be ignored.

* Thu Apr 11 2013 Lawrence Rogers <lrr@cert.org> 3.6.0-1
* Release 3.6.0-1
	Use the smaller SiLK-2 IPset memory representation for IPsets that contain only IPv4 addresses.
	Change sending output-mode in rwflowpack. Add a new incremental-files output-mode to rwflowpack.
	Have rwflowpack and flowcap record lost NetFlowV9 packets (requires libfixbuf-1.3.0).
	Add ability for rwreceiver to monitor disk usage.
	Verify that the --post-command switch and similar switches do not contain any unrecognized %-conversions.
	Many additional changes and bug fixes.

* Tue Mar 12 2013 Lawrence Rogers <lrr@cert.org> 3.5.1-2
* Release 3.5.1-2
	New release linked with libfixbuf 1.3.0

* Thu Dec 20 2012 Lawrence Rogers <lrr@cert.org> 3.5.1-1
* Release 3.5.1-1
	Fix bug in the IPset library that made it impossible to store very large IPset files.
	Various changes to rwsiteinfo.
	Fix issue in rwreceiver that could cause it to close valid connections.

* Thu Nov 1 2012 Lawrence Rogers <lrr@cert.org> 3.5.0-1
* Release 3.5.0-1
	Add country code support for IPv6 addresses.
	Fix issue in rwreceiver that could cause it to close valid connections.
	Fix a bug on 32-bit platforms when reading files compressed with LZO that could cause memory corruption.
	Modify how rwflowappend determines the hourly file in which flow records are to be stored.
	Several additional bug fixes.

* Thu Sep 27 2012 Lawrence Rogers <lrr@cert.org> 3.4.1-1
* Release 3.4.1-1
	Add new --tail-recs switch to rwcut.
	Fix issue where receiving incorrect data from a previously rejected UDP client could case rwflowpack or flowcap to exit.

* Thu Sep 13 2012 Lawrence Rogers <lrr@cert.org> 3.4.0-1
* Release 3.4.0-1
	Modify how SiLK decodes the ICMP type and code stored in certain SiLK Flow records.
	Provide the new configure option --disable-silk3-ipsets which causes SiLK to use the IPset library as it
		existed in SiLK-2. When this switch is used, IPsets cannot store IPv6 addresses.
	Add support for libfixbuf-1.2.0, which allows multiple NetFlow v9 sources to connect to the same port.
	Add enhancements to rwsetcat, rwsetmember, rwscan.
	Fix bugs in rwuniq, rwstats, rwcut, rwipfix2silk.

* Wed Aug 1 2012 Lawrence Rogers <lrr@cert.org> 3.3.4-1
* Release 3.3.4-1
	* Fix bug where rwscanquery would attempt to write a file beginning and ending with a quote character.
	* Fix potentional issue in rwsender when attempting to exit after encountering an unexpected condition.

* Thu Jul 19 2012 Lawrence Rogers <lrr@cert.org> 3.3.3-1
* Release 3.3.3-1
	* Fix bug in log file locking and rotation.

* Thu Jul 12 2012 Lawrence Rogers <lrr@cert.org> 3.3.2-1
* Release 3.3.2-1
	* Fixes in the IPset and Bag tools.

* Thu Jun 14 2012 Lawrence Rogers <lrr@cert.org> 3.3.0-1
* Release 3.3.0-1
	* Critical fixes in rwuniq, rwstats, and the IPset tools.
	* Enhancements to rwscanquery
	* In flowcap, new log messages record the number of record processed for IPFIX probes and NetFlow v9 probes.

* Thu Apr 26 2012 Lawrence Rogers <lrr@cert.org> 3.2.1-1
* Release 3.2.1-1
	* Fix an issue when using multiple compressed IPsets in rwfilter on MPI.
	* Make rwflowpack and flowcap more robust with respect to error codes returned by libfixbuf.
	* Fix issues that prevented daemons from shutting down cleanly on some BSD OSes.

* Tue Mar 20 2012 Lawrence Rogers <lrr@cert.org> 3.2.0-1
* Release 3.2.0-1
	* Fix an issue when creating files on MPI where the compression was set to "default" or "best".
	* Additional bug fixes.

* Wed Feb 15 2012 Lawrence Rogers <lrr@cert.org> 3.1.0-1
* Release 3.1.0-1
	* rwflowappend uses advisory write locks to prevent multiple rwflowappend processes from each attempting to write to the same file.
	* Fix several issues in handling IPFIX.
	* Ignore IPFIX records that report a byte or packet count of zero.

* Fri Sep 30 2011 Lawrence Rogers <lrr@cert.org> 3.0.0-1
* Release 3.0.0-1
	* Support for IPv6 addresses in IPsets, Bags, and Prefix Maps.
	* New tools: rwsiteinfo, rwpmaplookup, rwpdu2silk
	* Improved IPFIX support, including allowing collection from multiple sources on a single TCP port. libfixbuf-1.0.0 is now required.

